/* Ce démonstrateur a pour but d'effectuer une CAN sur les huit canneaux et à en lister
   les résultats numérisés sur le Moniteur de l'IDE à 115200baud.
   Noter que D13 est inutilisé pour pouvoir utiliser la LED Arduino.
   
 Compilateur v1.7.9 :                PGM               RAM dynamique
                               3400 Octets (11%)      302 Octets (14%)      */  

//--------------------- Définition des broches d'E/S ------------------------
#define CLOCK  9      // Horloge
#define Selection 10   // Selection du circuit intégré. 
#define DialogueOUT 11 // MOSI 
#define DialogueIN  12 // MISO 

//------------------------ Variables  du programme --------------------------
int CAN; 

void setup(){
  Serial.begin(115200); Serial.println(); Serial.println();
  Serial.print("Programme du 24 Octobre 2023"); Serial.println(); Serial.println();
  pinMode(Selection, OUTPUT); digitalWrite(Selection,HIGH);    // Désactiver le périphérique au démarrage.
  pinMode(DialogueOUT, OUTPUT); digitalWrite(DialogueOUT,LOW); // Désactiver le périphérique au démarrage.
  pinMode(CLOCK, OUTPUT); digitalWrite(CLOCK,LOW);             // Désactiver le périphérique au démarrage.
  pinMode(DialogueIN, INPUT);}

void loop() { 
  CAN = Lire_valeur(0); Serial.print("Canal 1 : "); Serial.println(CAN,DEC); 
  CAN = Lire_valeur(1); Serial.print("Canal 2 : "); Serial.println(CAN,DEC);
  CAN = Lire_valeur(2); Serial.print("Canal 3 : "); Serial.println(CAN,DEC); 
  CAN = Lire_valeur(3); Serial.print("Canal 4 : "); Serial.println(CAN,DEC);
  CAN = Lire_valeur(4); Serial.print("Canal 5 : "); Serial.println(CAN,DEC); 
  CAN = Lire_valeur(5); Serial.print("Canal 6 : "); Serial.println(CAN,DEC);
  CAN = Lire_valeur(6); Serial.print("Canal 7 : "); Serial.println(CAN,DEC); 
  CAN = Lire_valeur(7); Serial.print("Canal 8 : "); Serial.println(CAN,DEC);
  Serial.println();} 

int Lire_valeur(byte Canal){
  // REMARQUE : La séquence "Impulsion Horloge" se retrouve quatre fois dans cette procédure. Pour
  //            optimiser le code il serait possible de l'implémenter en procédure. ce n'est pas ce
  //            qui est fait pour que la fonction "Lire_valeur" soit la plus rapide possible pour
  //            augmenter au maximum la fréquence d'échantillonnage de l'oscilloscope.
  int Valeur_ADC = 0;
  byte Octet_de_commande = B11000000; // Démarrage en mode canal 3 qui sera ignoré.
  Octet_de_commande |= ((Canal) << 3);  // Sélection du canal.
  digitalWrite(Selection,LOW);  // Valide le circuit intégré.
  for (byte I = 7; I >= 3; I--){ // Positionner les BITs pour écrire.
      digitalWrite(DialogueOUT,Octet_de_commande&1 << I);
      digitalWrite(CLOCK,HIGH); digitalWrite(CLOCK,LOW);} // Impulsion Horloge.
  //------------- Ignoer les deux BITs nuls -------------
  digitalWrite(CLOCK,HIGH); digitalWrite(CLOCK,LOW); // Impulsion Horloge.
  digitalWrite(CLOCK,HIGH); digitalWrite(CLOCK,LOW); // Impulsion Horloge.
  //-----------------------------------------------------
  // ATTENTION : Ci dessous, bien que l'index I ne varie que de 11 à 0 pour lire les 12 BITs,
  //             il est obligatoire d'untiliser un int au lieu d'un byte.
  for (int I = 11; I >= 0; I--){ // Lecture des BITs de la conversion AD.
      Valeur_ADC += digitalRead(DialogueIN) << I;
      digitalWrite(CLOCK,HIGH); digitalWrite(CLOCK,LOW);} // Impulsion Horloge.
  digitalWrite(Selection, HIGH);  // Replace le circuit intégré en veille.
  return Valeur_ADC;}



