/* Seul le canal n°2 est échantillonné dans ce démonstrateur pour avoir à l'affichage du Moniteur
   un visuel facile à observer. À cadence maximale la valeur numérisée est indiquée. On peut ainsi
   expérimenter l'influence de VREF sur la broche 15 du MCP3208.
   La LED Arduino sert à mesurer la cadence d'échantillonnage avec un fréquencemètre.
   Dans ce but passer la ligne n°35 repérée par //@@@@@@@@@@@@@@@@@@@@@@@ en remarque.
   La fréquence d'échantillonnage mesurée est de 2582Hz.
   
   
 Compilateur v1.7.9 :                PGM               RAM dynamique
                               3078 Octets (11%)      1249 Octets (14%)      */  

//--------------------- Définition des broches d'E/S ------------------------
#define CLOCK  9      // Horloge
#define Selection 10   // Selection du circuit intégré. 
#define DialogueOUT 11 // MOSI 
#define DialogueIN  12 // MISO
#define LED_Arduino  13


//------------------------ Variables  du programme --------------------------
int CAN, PTR;
byte TAMPON[1023];

void setup(){
  Serial.begin(115200); Serial.println(); Serial.println();
  Serial.print("Programme du 24 Octobre 2023"); Serial.println(); Serial.println();
  pinMode(Selection, OUTPUT); digitalWrite(Selection,HIGH);    // Désactiver le périphérique au démarrage.
  pinMode(DialogueOUT, OUTPUT); digitalWrite(DialogueOUT,LOW); // Désactiver le périphérique au démarrage.
  pinMode(CLOCK, OUTPUT); digitalWrite(CLOCK,LOW);             // Désactiver le périphérique au démarrage.
  pinMode(LED_Arduino, OUTPUT); pinMode(DialogueIN, INPUT);
  PTR = 0;}

void loop() {CAN = Lire_valeur(1);
   PTR++; if (PTR == 1024) PTR = 0; TAMPON[PTR] = CAN;
  digitalWrite(LED_Arduino,HIGH); digitalWrite(LED_Arduino,LOW);
  Serial.print("Canal 2 : "); Serial.println(CAN,DEC); //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  } // Fermeture ici pour pouvoir passer la ligne ci-dessus en remarque.

int Lire_valeur(byte Canal){
  // REMARQUE : La séquence "Impulsion Horloge" se retrouve quatre fois dans cette procédure. Pour
  //            optimiser le code il serait possible de l'implémenter en procédure. ce n'est pas ce
  //            qui est fait pour que la fonction "Lire_valeur" soit la plus rapide possible pour
  //            augmenter au maximum la fréquence d'échantillonnage de l'oscilloscope.
  int Valeur_ADC = 0;
  byte Octet_de_commande = B11000000; // Démarrage en mode canal 3 qui sera ignoré.
  Octet_de_commande |= ((Canal) << 3);  // Sélection du canal.
  digitalWrite(Selection,LOW);  // Valide le circuit intégré.
  for (byte I = 7; I >= 3; I--){ // Positionner les BITs pour écrire.
      digitalWrite(DialogueOUT,Octet_de_commande&1 << I);
      digitalWrite(CLOCK,HIGH); digitalWrite(CLOCK,LOW);} // Impulsion Horloge.
  //------------- Ignoer les deux BITs nuls -------------
  digitalWrite(CLOCK,HIGH); digitalWrite(CLOCK,LOW); // Impulsion Horloge.
  digitalWrite(CLOCK,HIGH); digitalWrite(CLOCK,LOW); // Impulsion Horloge.
  //-----------------------------------------------------
  // ATTENTION : Ci dessous, bien que l'index I ne varie que de 11 à 0 pour lire les 12 BITs,
  //             il est obligatoire d'untiliser un int au lieu d'un byte.
  for (int I = 11; I >= 0; I--){ // Lecture des BITs de la conversion AD.
      Valeur_ADC += digitalRead(DialogueIN) << I;
      digitalWrite(CLOCK,HIGH); digitalWrite(CLOCK,LOW);} // Impulsion Horloge.
  digitalWrite(Selection, HIGH);  // Replace le circuit intégré en veille.
  return Valeur_ADC;}

