/* Ce programme a pour but de remplir l'EEPROM avec le dernier contenu pour les textes.
   Quand ce programme aura été téléversé et activé, il servira pour les textes définitifs
   des démonstrateurs à partir de P15 inclus jusqu'au logiciel d'exploitation.
   Il génère en haut de l'EEPROM l'échantillonnage d'une sinusoïde amortie.
   
   NOTE : Placer des textes en EEPROM devient rentable dès que la chaine fait
          deux caractères.

Compilateur v1.7.9 :                  PGM               RAM dynamique
Textes dans le programme :      7188 Octets (23%)      834 Octets (40%) */

#include <EEPROM.h>
//------------------- Déclaration des constante du programme ----------------
#define Version_logiciel "Contenu EEPROM du Dimanche 4 Decembre 2023." //@@@@@@@@@@@@@@@@@@@@@@@@@
#define Debut_Hexadecimal 538 // Adresse de fin des textes pour du listage en HEXADECIMAL

//----------------------- Déclaration des variables -------------------------
char Caractere;
byte Amplitude, HYD, OCTET, Octet, TMP;
int CO2, PTR;
String TEXTE_a_inscrire_en_EEPROM = ""; // Emplacement pour la chaîne entrante.

void setup() {
  Serial.begin(57600);
  Serial.println(); Serial.println(); Serial.println(Version_logiciel); Serial.println();
  TEXTE_a_inscrire_en_EEPROM.reserve(30); // 30 caractères sont très suffisants.
  //--------------------------------------------------------------------
  // Effacement complet de la zone de texte avec des $FF.
  Serial.println(F("Remplissage EEPROM avec des $FF.")); Serial.println();
  PTR = 0; for (PTR=0; PTR < 548; PTR++) EEPROM.write(PTR, 255);
  //--------------------------------------------------------------------
  Serial.println(F("Ecriture en EEPROM des textes :")); Serial.println();
  PTR = 0; // PTR pointe la première adresse en début d'EEPROM.
  TEXTE_a_inscrire_en_EEPROM = "MENU de BASE.HAUT : BAS : Afficher TRACE."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "GAUCHE : Menu EEPROM.DROITE : Sortie USB."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "1.35mS1.252.5v VeffNum"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, char(233)); PTR++;
  TEXTE_a_inscrire_en_EEPROM = "riserSYNCHRONISATION."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "H : FM.B : FD.G : Seuil > D : Sortie.  "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "OUINONBASE de TEMPSDur"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, char(233)); PTR++;
  TEXTE_a_inscrire_en_EEPROM = "e : Total : Fen"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, char(234)); PTR++;
  TEXTE_a_inscrire_en_EEPROM = "tre : Pas de TRACE !"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "EffacerLongue QuatreEEPROM."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Recharger.Sauvegarder."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Compl"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, char(232)); PTR++;
  TEXTE_a_inscrire_en_EEPROM = "te.ChangeATTENTION : 4 "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "On les remplace ? la S.)"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Listage du contenu de l'"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " ADRS  00 01 02 03 04 05 06"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " 07 08 09 0A 0B 0C 0D 0E 0F"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "du RESETBdT.Version O/N."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "0.643S0.16SInit "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "PILE - TAS = sur"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Version logicielle(FE6AAE)"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "signalbaud. Calibrev   "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Exporte sur USB :Sinuso"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, char(239)); PTR++;
  TEXTE_a_inscrire_en_EEPROM = "dal."; Ecrire_Texte_en_EEPROM();
  
  //---------------------- Créer une trace fictive en EEPROM ----------------------
  Serial.println(); Serial.println(F("Inscription des Echantillons en EEPROM.")); Serial.println();
  PTR = Debut_Hexadecimal; EEPROM.write(PTR,false);
  // Trace une sinusoïde amortie avec décrément linéaire.
  for (PTR = Debut_Hexadecimal + 1; PTR < 548; PTR++) EEPROM.write(PTR,2); PTR = 547;
  // Ci-dessus Gain x1 donc calibre 5v et BdT = 2mS pour les quatre fenêtres et Trace Longue.
  for (int Echantillon = 0; Echantillon < 476; Echantillon++) {
       Amplitude = 127 - (Echantillon >> 2); // Shitt de >> 2 pour diviser la valeur par 4.
       PTR++; EEPROM.write(PTR, (128 + sin(radians(Echantillon * 6)) * Amplitude));}
       // Ci-dessus la valeur 6 représente la fréquence du signal.
  //-------------------------------------------------------------------------------
  Lister_EEPROM();}

void loop() {} // la boucle de base ne fait rien !
  
void Ecrire_Texte_en_EEPROM(){
  byte Curseur = 0; // Pointer le premier caractère du TEXTE.
  // Ne pas déborder la taille mémoire disponible en EEPROM.
  // N'envoyer que le TEXTE. */
  while ((PTR < 1024) && (TEXTE_a_inscrire_en_EEPROM[Curseur] != '\0')) {
     EEPROM.write(PTR, TEXTE_a_inscrire_en_EEPROM[Curseur]);
     Serial.print(TEXTE_a_inscrire_en_EEPROM[Curseur]); Curseur++; PTR++;}
     Serial.println();}

void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++;}}
 
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC();}

void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}

void Affiche_octet_ECHANTILLON() {
  if (OCTET < 16) Serial.print('0'); Serial.print(OCTET,HEX);}
 
void Lister_OCTET() {
  OCTET = EEPROM.read(PTR);
  if (PTR < Debut_Hexadecimal) {  
     if ((OCTET > 31) && (OCTET < 126)) {Serial.print(' '); Serial.print(char(OCTET));}
     else Serial.print("..");}
  else Affiche_octet_ECHANTILLON();
  Serial.print(' '); PTR++; }
  
  
