/* Ce programme a pour but de remplir l'EEPROM avec le dernier contenu pour les textes.
   Quand ce programme aura été téléversé et activé, téléverser ensuite les démonstrateurs qui
   suivent et le logiciel d'exploitation pour la version 5.
   Il génère une trace fictive d'échantillonnage. */

#include <EEPROM.h>
//------------------- Déclaration des constante du programme ----------------
#define Version_logiciel "Contenu EEPROM du 7 Novembre 2023." //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

//----------------------- Déclaration des variables -------------------------
char Caractere;
byte HYD, OCTET, Octet, TMP;
int CO2, PTR;
String TEXTE_a_inscrire_en_EEPROM = ""; // Emplacement pour la chaîne entrante.

void setup() {
  Serial.begin(115200);
  Serial.println(); Serial.println(); Serial.println(Version_logiciel); Serial.println();
  TEXTE_a_inscrire_en_EEPROM.reserve(30); // 30 caractères sont très suffisants.
  //--------------------------------------------------------------------
  // Effacement complet de la zone de texte avec des $FF.
  Serial.println(F("Remplissage EEPROM avec des $FF.")); Serial.println();
  PTR = 0; for (PTR=0; PTR < 512; PTR++) EEPROM.write(PTR, 255);
  //--------------------------------------------------------------------
  Serial.println(F("Ecriture en EEPROM des textes :")); Serial.println();
  PTR = 0; // PTR pointe la première adresse en début d'EEPROM.
  TEXTE_a_inscrire_en_EEPROM = "Rev : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Trace actuelle : Haut"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Trace en EEPROM : Bas"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "RAZ EEPROM : Gauche"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Un B.P. pour sortir."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Trace longue."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "OUI : BP Haut."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "NON : BP Bas."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Stocker la TRACE ?"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Stocker : Droite"; Ecrire_Texte_en_EEPROM();
  //---------------------- Créer une trace fictive en EEPROM ----------------------
  Serial.println(); Serial.println(F("Inscription des Echantillons en EEPROM.")); Serial.println();
  PTR = 511; EEPROM.write(PTR, 5); // Nature de l'enregistrement dans l'EEPROM.
  for (int Echantillon = 0; Echantillon < 512; Echantillon++) {
        PTR++; EEPROM.write(PTR, (128 + sin(radians(Echantillon * 4)) * 127));}
  //-------------------------------------------------------------------------------
  Lister_EEPROM();}

void loop() {} // la boucle de base ne fait rien !
  
void Ecrire_Texte_en_EEPROM(){
  byte Curseur = 0; // Pointer le premier caractère du TEXTE.
  // Ne pas déborder la taille mémoire disponible en EEPROM.
  // N'envoyer que le TEXTE. */
  while ((PTR < 1024) && (TEXTE_a_inscrire_en_EEPROM[Curseur] != '\0')) {
     EEPROM.write(PTR, TEXTE_a_inscrire_en_EEPROM[Curseur]);
     Serial.print(TEXTE_a_inscrire_en_EEPROM[Curseur]); Curseur++; PTR++;}
     Serial.println();}

void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++;}}
 
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC();}

void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}

void Affiche_octet_ECHANTILLON() {
  if (OCTET < 16) Serial.print('0'); Serial.print(OCTET,HEX);}
 
void Lister_OCTET() {
  OCTET = EEPROM.read(PTR);
  if (PTR < 511) {  
     if ((OCTET > 31) && (OCTET < 126)) {Serial.print(' '); Serial.print(char(OCTET));}
     else {if (PTR >= 693) Affiche_octet_ECHANTILLON(); else Serial.print("..");}}
  else Affiche_octet_ECHANTILLON();
  Serial.print(' '); PTR++; }
  
  
